Index: /NEMO/branches/2019/dev_r11708_aumont_PISCES_QUOTA/src/TOP/TRP/trcrad.F90
===================================================================
--- /NEMO/branches/2019/dev_r11708_aumont_PISCES_QUOTA/src/TOP/TRP/trcrad.F90	(revision 14275)
+++ /NEMO/branches/2019/dev_r11708_aumont_PISCES_QUOTA/src/TOP/TRP/trcrad.F90	(revision 14276)
@@ -107,5 +107,5 @@
       ENDIF
       !
-      ALLOCATE( gainmass(jptra,2) )
+      ALLOCATE( gainmass(jptra,4) )
       gainmass(:,:) = 0.
       !
@@ -169,7 +169,8 @@
                         IF( ptrb(ji,jj,jk,jn) > 0. ) THEN                         ! use positive values to compensate mass gain
                            zcoef = 1. + ztrneg(ji,jj,jn) / ztrpos(ji,jj,jn)       ! ztrpos > 0 as ptrb > 0
+                           gainmass(jn,1) = gainmass(jn,1) + ptrb(ji,jj,jk,jn) * cvol(ji,jj,jk) * ( zcoef - 1.0 )  ! we are correcting mass...
                            ptrb(ji,jj,jk,jn) = ptrb(ji,jj,jk,jn) * zcoef
                            IF( zcoef < 0. ) THEN                                  ! if the compensation exceed the positive value
-                              gainmass(jn,1) = gainmass(jn,1) - ptrb(ji,jj,jk,jn) * cvol(ji,jj,jk)   ! we are adding mass...
+                              gainmass(jn,2) = gainmass(jn,2) - ptrb(ji,jj,jk,jn) * cvol(ji,jj,jk)   ! we are adding mass...
                               ptrb(ji,jj,jk,jn) = 0.                              ! limit the compensation to keep positive value
                            ENDIF
@@ -190,9 +191,11 @@
          IF( kt == nitend ) THEN
             CALL mpp_sum( 'trcrad', gainmass(:,1) )
+            CALL mpp_sum( 'trcrad', gainmass(:,2) )
             DO jn = jp_sms0, jp_sms1
-               IF( gainmass(jn,1) > 0. ) THEN
+               IF( gainmass(jn,1) < 0. ) THEN
                   ztotmass = glob_sum( 'trcrad', ptrb(:,:,:,jn) * cvol(:,:,:) )
-                  IF(lwp) WRITE(numout, '(a, i2, a, D23.16, a, D23.16)') 'trcrad ptrb, traceur ', jn  &
-                     &        , ' total mass : ', ztotmass, ', mass gain : ',  gainmass(jn,1)
+                  IF(lwp) WRITE(numout, '(a, i2, a, D23.16, a, D23.16, a, D23.16)') 'trcrad ptrb, traceur ', jn  &
+                     &        , ' total mass : ', ztotmass, ', mass correction : ',  gainmass(jn,1)   &
+                     &        , ' mass gain : ', gainmass(jn,2)
                END IF
             END DO
@@ -219,7 +222,8 @@
                         IF( ptrn(ji,jj,jk,jn) > 0. ) THEN                         ! use positive values to compensate mass gain
                            zcoef = 1. + ztrneg(ji,jj,jn) / ztrpos(ji,jj,jn)       ! ztrpos > 0 as ptrb > 0
+                           gainmass(jn,3) = gainmass(jn,3) + ptrn(ji,jj,jk,jn) * cvol(ji,jj,jk) * ( zcoef - 1.0 )  ! we are correcting mass...
                            ptrn(ji,jj,jk,jn) = ptrn(ji,jj,jk,jn) * zcoef
                            IF( zcoef < 0. ) THEN                                  ! if the compensation exceed the positive value
-                              gainmass(jn,2) = gainmass(jn,2) - ptrn(ji,jj,jk,jn) * cvol(ji,jj,jk)   ! we are adding mass...
+                              gainmass(jn,4) = gainmass(jn,4) - ptrn(ji,jj,jk,jn) * cvol(ji,jj,jk)   ! we are adding mass...
                               ptrn(ji,jj,jk,jn) = 0.                              ! limit the compensation to keep positive value
                            ENDIF
@@ -239,10 +243,12 @@
  
          IF( kt == nitend ) THEN
-            CALL mpp_sum( 'trcrad', gainmass(:,2) )
+            CALL mpp_sum( 'trcrad', gainmass(:,3) )
+            CALL mpp_sum( 'trcrad', gainmass(:,4) )
             DO jn = jp_sms0, jp_sms1
-               IF( gainmass(jn,2) > 0. ) THEN
+               IF( gainmass(jn,3) < 0. ) THEN
                   ztotmass = glob_sum( 'trcrad', ptrn(:,:,:,jn) * cvol(:,:,:) )
-                  WRITE(numout, '(a, i2, a, D23.16, a, D23.16)') 'trcrad ptrn, traceur ', jn  &
-                     &        , ' total mass : ', ztotmass, ', mass gain : ',  gainmass(jn,1)
+                  IF(lwp) WRITE(numout, '(a, i2, a, D23.16, a, D23.16, a, D23.16)') 'trcrad ptrn, traceur ', jn  &
+                     &        , ' total mass : ', ztotmass, ', mass correction : ',  gainmass(jn,3)   &
+                     &        , ' mass gain : ', gainmass(jn,4)
                END IF
             END DO
Index: /NEMO/branches/2019/dev_r11708_aumont_PISCES_QUOTA/src/TOP/trcnam.F90
===================================================================
--- /NEMO/branches/2019/dev_r11708_aumont_PISCES_QUOTA/src/TOP/trcnam.F90	(revision 14275)
+++ /NEMO/branches/2019/dev_r11708_aumont_PISCES_QUOTA/src/TOP/trcnam.F90	(revision 14276)
@@ -248,5 +248,5 @@
       !!---------------------------------------------------------------------
 #if defined key_trdmxl_trc  || defined key_trdtrc
-      INTEGER  ::   ios, ierr                 ! Local integer
+      INTEGER  ::   jn, ios, ierr                 ! Local integer
       !!
       NAMELIST/namtrc_trd/ nn_trd_trc, nn_ctls_trc, rn_ucf_trc, &
@@ -260,4 +260,5 @@
       !
       ALLOCATE( ln_trdtrc(jptra) ) 
+      ln_trdtrc(:) = .false.
       !
       REWIND( numnat_ref )              ! Namelist namtrc_trd in reference namelist : Passive tracer trends
@@ -267,5 +268,5 @@
       READ  ( numnat_cfg, namtrc_trd, IOSTAT = ios, ERR = 906 )
 906   IF( ios >  0 )   CALL ctl_nam ( ios , 'namtrc_trd in configuration namelist' )
-      IF(lwm) WRITE( numont, namtrc_trd )
+     IF(lwm) WRITE( numont, namtrc_trd )
 
       IF(lwp) THEN
